// Bremsflssigkeitstester
// copyright 2014 von nicomania.de unter der creative commons Lizenz

#define F_CPU 1200000UL	//9,6/8 = 1,2 MHz
 
#include <stdio.h>
#include <stdlib.h>		//Miscellaneous routines
#include <avr/io.h>		//Includes other I/O-Headers
#include <util/delay.h>
#include <avr/interrupt.h>	//Interrupt handling routines
#include <inttypes.h>		//Defines for different int data types
#include <avr/sleep.h>
 
#define SCHWELLE_1_5 783	//Schwelle fr 1,5% Wasseranteil
#define SCHWELLE_3_0 398	//Schwelle fr 3,0% Wasseranteil
#define ANZAHL_MESSUNGEN 5	//Anzahl der Messungen fr Durchschnittswert
#define AD_KANAL 3		//Kanal fr AD Wandlung
#define LEUCHTEN 2000		//Leuchtdauer fr LED in ms
 
 
void led(unsigned char farbe, uint16_t zeit) 
{	
	if (farbe == 'R')
	{
		PORTB &= ~(1<<PB3);	// low
		for (zeit=zeit/10; zeit>0; zeit--) _delay_ms(10);
		PORTB |= (1<<PB3);	// high
	}
	else if (farbe == 'G')
	{
		PORTB &= ~(1<<PB2);	// low
		for (zeit=zeit/10; zeit>0; zeit--) _delay_ms(10);
		PORTB |= (1<<PB2);	// high
	}
	else if (farbe == 'B')
	{
		PORTB &= ~(1<<PB1);	// low
		for (zeit=zeit/10; zeit>0; zeit--) _delay_ms(10);
		PORTB |= (1<<PB1);	// high
	}
}
 
 
uint16_t adc(uint8_t pin)
{
	uint32_t ADC_Summe = 0;
	uint8_t i = 0;
 
	ADCSRA |= (1<<ADEN);	//ADC aktivieren
	ADMUX = (ADMUX & ~(0x1F)) | (pin & 0x1F);	//Pin whlen
 
	ADCSRA |= (1<<ADSC);	//Dummy-Messung starten
	while (ADCSRA & (1<<ADSC)) ;	//auf Abschluss der Messung warten
	(void)ADCW;		//Ergebnis verwerfen
 
	while(i < ANZAHL_MESSUNGEN+1) {
		ADCSRA |= (1<<ADSC);	//Messung starten
		while (ADCSRA & (1<<ADSC)) ;	//auf Abschluss der Messung warten
		ADC_Summe += ADCW;	//Ergebnis aufsummieren
		i++;
	}
 
	ADCSRA &= (0<<ADEN);	//ADC deaktivieren
	return (ADC_Summe/ANZAHL_MESSUNGEN);	//Ergebnis zurckgeben
}
 
 
int main(void)
{
	       //543210
	DDRB  = 0b001110;       //Ausgang=1, Eingang=0
	PORTB = 0b001111;       //preset Ausgnge / pullup Eingnge (unbenutzt: pullup ein!)
 
	//PCINT0 einstellen
	GIMSK |= (1<<PCIE);		//PCINT enable
	PCMSK |= (1<<PCINT0);	//PCINT Maske
 
	//ADC einstellen
	ADMUX &= ~(1<<REFS0);	//AVCC als Referenz (0=AVCC, 1=1.1V)
	ADCSRA |= (1<<ADPS1) | (1<<ADPS0);	//ADC prescaler auf 8 (ADclk mit 150khz)
 
	sei();		//enable global Interrupts
 
    while(1)
    {
		set_sleep_mode(SLEEP_MODE_PWR_DOWN);	// Schlafmodus whlen
		sleep_mode();			// schlafen schicken
 
		// <-- hier wird wieder aufgewacht
 
	}
 
    return 0;
}
 
 
ISR(PCINT0_vect)
{
	if (!(PINB & (1<<PB0)))	//wenn fallende Flanke
	{
		//Output Test
		led('R', 100);
		led('G', 100);
		led('B', 100);
		_delay_ms(100);
 
		//Messung starten
		uint16_t messung = adc(AD_KANAL);
 
		//Messung auswerten
		if (messung >= SCHWELLE_1_5)
		{
			led('G', LEUCHTEN);
		}
		else if ((messung < SCHWELLE_1_5) && (messung > SCHWELLE_3_0))
		{
			led('B', LEUCHTEN);
		} 
		else if (messung <= SCHWELLE_3_0)
		{
			led('R', LEUCHTEN);
		}
 
		//PCI Flag loeschen
		GIFR |= (1<<PCIF);
	}
}

